#ifndef IMCA_XIA_FILTERS_H
#define IMCA_XIA_FILTERS_H

#include <stddef.h>

#define IMCA_XIA_FILTERS_MAX_NUM_FILTERS 8
#define IMCA_XIA_FILTERS_MAX_NUM_THICKNESSES 256

struct ImcaXiaFilterSet {
  double thickness;
  short states[IMCA_XIA_FILTERS_MAX_NUM_FILTERS];
  double attenuation;
};

struct ImcaXiaFiltersData {
  double filterThicknesses[IMCA_XIA_FILTERS_MAX_NUM_FILTERS];
  struct ImcaXiaFilterSet filterSets[IMCA_XIA_FILTERS_MAX_NUM_THICKNESSES];
  int numFilterSets;
};

extern int imcaXiaAreAllStatesSame(short states[], size_t statesSize);
extern int imcaXiaFiltersFindNearestAttenuation(
  struct ImcaXiaFiltersData *data, double attenuation);
extern int imcaXiaFiltersFindNearestThickness(struct ImcaXiaFiltersData *data,
  double thickness);
extern void imcaXiaFiltersInitialize(struct ImcaXiaFiltersData *data,
  double filterThicknesses[], size_t filterThicknessesSize,
  double attenuationCoefficient);
extern void imcaXiaFiltersUpdateAttenuation(struct ImcaXiaFiltersData *data,
  double attenuationCoefficient);

#endif
