#!/bin/sh

appName='imcaXiaPfcu4'

if [ "X$1" = 'X-h' -o "X$1" = 'X--help' ]; then
  echo 'Usage: control.sh [P [D [D1 [D2]]]]'
  echo 'Parameters:'
  echo '  P   PV prefix (default: "x7idb:")'
  echo '  D   Name of device (default: "FltrRak1")'
  echo '  D1  Name of subdevice for filters 1-4 (default: "XiaPfcu1")'
  echo '  D2  Name of subdevice for filters 5-8 (default: "XiaPfcu2")'
  echo 'Example: control.sh'
  echo 'Example: control.sh ioc23: FltrRak2 XiaPfcu3 XiaPfcu4'
  exit 0
fi

argP='x7idb:'
if [ "X$1" != 'X' ]; then argP="$1"; fi
argD='FltrRak1'
if [ "X$2" != 'X' ]; then argD="$2"; fi
argD1='XiaPfcu1'
if [ "X$3" != 'X' ]; then argD1="$3"; fi
argD2='XiaPfcu2'
if [ "X$4" != 'X' ]; then argD2="$4"; fi

thisScriptHome=`dirname "$0"`
cd "$thisScriptHome"
if [ $? -ne 0 ]; then
  echo "Error: failed to cd to \"$thisScriptHome\"." 1>&2
  exit 1
fi
thisScriptHome=`pwd`
if [ $? -ne 0 ]; then
  echo 'Error: failed to get current working directory.' 1>&2
  exit 1
fi

cd "../${appName}App/op/adl"
if [ $? -ne 0 ]; then
  echo -n 'Error: failed to cd to ' 1>&2
  echo "\"$thisScriptHome/../${appName}App/op/adl\"." 1>&2
  exit 1
fi

exec medm -x -macro "P=$argP,D=$argD,D1=$argD1,D2=$argD2" ./imcaXiaPfcu4x2.adl
